﻿
Imports System
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.EditorInput

Imports Autodesk.AutoCAD.Windows

Imports System.Windows.Controls

<Assembly: CommandClass(GetType(dotNetTraining_Webcast_Demos.Webcast_4_Demos))> 

Namespace dotNetTraining_Webcast_Demos


    Public Class Webcast_4_Demos

        ' Global variable for the the PalleteSet
        Public m_PaletteSet As PaletteSet

        ' Global for the user control
        Public m_UserCtrl As UserControl1


        <CommandMethod("demoPalette")> _
        Public Sub paletteDemo()

            ' ensure that PaletteSet is not created
            If (m_PaletteSet = Nothing) Then

                ' create a new paletteSet
                m_PaletteSet = New PaletteSet("Demo Palette", New Guid("D915E49E-45C8-41FD-AC60-B4D3696D93C8"))

                ' new user control
                m_UserCtrl = New UserControl1

                ' add the User Control
                m_PaletteSet.Add("Demo Palette ", m_UserCtrl)

            End If

            ' make the PaletteSet visible
            m_PaletteSet.Visible = True


        End Sub



        <CommandMethod("DemoEvents")> _
        Public Sub eventsDemo()

            ' ensure the palette is created
            If m_PaletteSet Is Nothing Then

                Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

                ' tell the user to run the command
                ed.WriteMessage(vbCr + "Run the DemoPalette command first")

                Return

            End If

            ' Get the database
            Dim db As Database = Application.DocumentManager.MdiActiveDocument.Database

            ' Add the ObjectAppended event
            AddHandler db.ObjectAppended, New ObjectEventHandler(AddressOf objectAppended)

            ' Add the ObjectErased call back or handler
            AddHandler db.ObjectErased, New ObjectErasedEventHandler(AddressOf objectErased)

            ' Get the active document
            Dim doc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument

            ' Add a commandEnded event
            AddHandler doc.CommandEnded, New CommandEventHandler(AddressOf cmdEnded)

        End Sub


        Private Sub objectAppended(ByVal sender As Object, ByVal e As ObjectEventArgs)

            ' Add an entry to the list box
            m_UserCtrl.ListBox1.Items.Add(e.DBObject.GetType().ToString())


        End Sub



        Private Sub objectErased(ByVal sender As Object, ByVal e As ObjectErasedEventArgs)

            If e.Erased Then
                Dim strLBItem As String
                ' going through each of the items in the list box
                For Each strLBItem In m_UserCtrl.ListBox1.Items
                    ' Testing the type of entity as a string
                    If strLBItem = e.DBObject.GetType().ToString() Then
                        ' remove that string
                        m_UserCtrl.ListBox1.Items.Remove(strLBItem)

                        Exit For
                    End If
                Next

            End If

        End Sub


        Public Sub cmdEnded(ByVal o As Object, ByVal e As CommandEventArgs)
            Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

            ' tell the command was run
            ed.WriteMessage("You ran the command " + e.GlobalCommandName + vbCrLf)


        End Sub


        <CommandMethod("DemoRemoveEvents")> _
        Public Sub removeEventsDemo()
            ' Get the database
            Dim db As Database = Application.DocumentManager.MdiActiveDocument.Database
            ' remove the ObjectAppended event callback
            RemoveHandler db.ObjectAppended, AddressOf objectAppended
            ' remove the ObjectErased callback
            RemoveHandler db.ObjectErased, AddressOf objectErased

            ' get the document
            Dim doc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument
            ' Remove the CommandEnded callback
            RemoveHandler doc.CommandEnded, AddressOf cmdEnded
           
        End Sub
    End Class

End Namespace